searchNodes=[{"doc":"The Spotity Annoy library as a NIF.","ref":"AnnoyEx.html","title":"AnnoyEx","type":"module"},{"doc":"Adds item i (any nonnegative integer) with list v","ref":"AnnoyEx.html#add_item/3","title":"AnnoyEx.add_item/3","type":"function"},{"doc":"builds a forest of n_trees trees. More trees gives higher precision when querying. After calling build, no more items can be added. n_jobs specifies the number of threads used to build the trees. n_jobs=-1 uses all available CPU cores.","ref":"AnnoyEx.html#build/3","title":"AnnoyEx.build/3","type":"function"},{"doc":"returns the distance between items i and j .","ref":"AnnoyEx.html#get_distance/3","title":"AnnoyEx.get_distance/3","type":"function"},{"doc":"Returns the vector for item i that was previously added.","ref":"AnnoyEx.html#get_item_vector/2","title":"AnnoyEx.get_item_vector/2","type":"function"},{"doc":"Returns the number of items in the index.","ref":"AnnoyEx.html#get_n_items/1","title":"AnnoyEx.get_n_items/1","type":"function"},{"doc":"Returns the number of trees in the index.","ref":"AnnoyEx.html#get_n_trees/1","title":"AnnoyEx.get_n_trees/1","type":"function"},{"doc":"Returns the n closest items to the item at position i . During the query it will inspect up to search_k nodes, which defaults to n_trees * n if not provided. search_k gives you a run-time tradeoff between better accuracy and speed. If you set include_distances to true . Returns a 2 element tuple with two lists in it: results and distances.","ref":"AnnoyEx.html#get_nns_by_item/5","title":"AnnoyEx.get_nns_by_item/5","type":"function"},{"doc":"Same as get_nns_by_item but query by list v Returns a 2 element tuple with two lists in it: results and distances.","ref":"AnnoyEx.html#get_nns_by_vector/5","title":"AnnoyEx.get_nns_by_vector/5","type":"function"},{"doc":"","ref":"AnnoyEx.html#init/0","title":"AnnoyEx.init/0","type":"function"},{"doc":"Loads (mmaps) an index from disk. Full path must be given.","ref":"AnnoyEx.html#load/3","title":"AnnoyEx.load/3","type":"function"},{"doc":"Initializes a new index that's read-write and stores vector of f dimensions. Available metrics: :angular - The default. :euclidean :manhattan :dot","ref":"AnnoyEx.html#new/2","title":"AnnoyEx.new/2","type":"function"},{"doc":"prepares annoy to build the index in the specified file instead of RAM (execute before adding items, no need to save after build)","ref":"AnnoyEx.html#on_disk_build/2","title":"AnnoyEx.on_disk_build/2","type":"function"},{"doc":"Saves the index to disk. Full path must be given.","ref":"AnnoyEx.html#save/3","title":"AnnoyEx.save/3","type":"function"},{"doc":"will initialize the random number generator with the given seed. Only used for building up the tree, i.e. only necessary to pass this before adding the items. Will have no effect after calling build or load","ref":"AnnoyEx.html#set_seed/2","title":"AnnoyEx.set_seed/2","type":"function"},{"doc":"Unbuilds.","ref":"AnnoyEx.html#unbuild/1","title":"AnnoyEx.unbuild/1","type":"function"},{"doc":"Unloads.","ref":"AnnoyEx.html#unload/1","title":"AnnoyEx.unload/1","type":"function"},{"doc":"Set verbosity.","ref":"AnnoyEx.html#verbose/2","title":"AnnoyEx.verbose/2","type":"function"},{"doc":"","ref":"AnnoyEx.html#t:ok_or_err_tuple/0","title":"AnnoyEx.ok_or_err_tuple/0","type":"type"},{"doc":"A NIF binding to Annoy , Spotify's C++ library for approximate nearest neighbors. It implements all of the methods in the Spotify library and all index types except Hamming. Code Examples","ref":"readme.html","title":"AnnoyEx","type":"extras"},{"doc":"iex(1)&gt; f = 40 40 iex(2)&gt; t = AnnoyEx . new ( f ) # Reference &lt; 0.3703577626 . 1733689351.247165 &gt; iex(3)&gt; Enum . each ( 0 .. 999 , ...(3)&gt; fn i -&gt; AnnoyEx . add_item ( t , i , Enum . map ( 0 .. f - 1 , fn _ -&gt; :rand . normal ( ) end ) ) ...(3)&gt; end ) :ok iex(4)&gt; AnnoyEx . build ( t , 10 ) :ok iex(5)&gt; AnnoyEx . save ( t , &quot;test.ann&quot; ) :ok iex(6)&gt; u = AnnoyEx . new ( f , :angular ) # Reference &lt; 0.3703577626 . 1733689345.248447 &gt; iex(7)&gt; AnnoyEx . load ( u , &quot;test.ann&quot; ) # super fast, will just mmap the file :ok iex(8)&gt; AnnoyEx . get_nns_by_item ( u , 0 , 10 ) # will find the 10 nearest neighbors { [ 0 , 677 , 837 , 478 , 793 , 183 , 265 , 623 , 751 , 268 ] , [ 0.0 , 1.1232969760894775 , 1.1271791458129883 , 1.1428979635238647 , 1.1504143476486206 , 1.1632753610610962 , 1.1647002696990967 , 1.1801577806472778 , 1.2018792629241943 , 1.2058889865875244 ] }","ref":"readme.html#if-you-have-your-own-vectors","title":"AnnoyEx - If you have your own vectors.","type":"extras"},{"doc":"Go to https://nlp.stanford.edu/projects/glove/ and download a word-embedding file, eg. https://nlp.stanford.edu/data/glove.42B.300d.zip By its nature creating and building the index can be quite slow but querying afterward is fast. Saving built indexes can help with this. # Build and save the index. idx = AnnoyEx . new ( 300 ) index_to_word = File . stream! ( &quot;glove.42B.300d.txt&quot; ) |&gt; Stream . with_index ( ) |&gt; Stream . map ( fn { line , item } -&gt; fields = String . trim_trailing ( line ) |&gt; String . split ( &quot; &quot; ) word = hd ( fields ) vec = Enum . map ( tl ( fields ) , fn x -&gt; Float . parse ( x ) |&gt; elem ( 0 ) end ) AnnoyEx . add_item ( idx , item , vec ) { item , word } end ) |&gt; Enum . into ( %{ } ) AnnoyEx . build ( idx , 10 ) AnnoyEx . save ( idx , &quot;glove.42B.300d.idx&quot; ) File . write! ( &quot;glove.42B.300d.i2w&quot; , :erlang . term_to_binary ( index_to_word ) ) The saved data can now be queried for similar words, eg. the 10 closest words to &quot;dog&quot;: iex(1)&gt; index_to_word = File . read! ( &quot;glove.42B.300d.i2w&quot; ) |&gt; :erlang . binary_to_term %{ 1774702 =&gt; &quot;bedanya&quot; , ... } iex(2)&gt; word_to_index = Map . new ( index_to_word , fn { k , v } -&gt; { v , k } end ) %{ &quot;timout&quot; =&gt; 816588 , ... } iex(3)&gt; idx = AnnoyEx . new ( 300 ) # Reference &lt; 0.2696563938 . 657326081.165701 &gt; iex(4)&gt; AnnoyEx . load ( idx , &quot;glove.42B.300d.idx&quot; ) :ok iex(5)&gt; dog_id = word_to_index [ &quot;dog&quot; ] 828 iex(6)&gt; { word_ids , distances } = AnnoyEx . get_nns_by_item ( idx , dog_id , 10 ) { [ 828 , 1818 , 5203 , 3394 , 1642 , 1937 , 6798 , 16091 , 7080 , 16440 ] , [ 0.0 , 0.5301183462142944 , 0.617365300655365 , 0.7635669112205505 , 0.8098030686378479 , 0.8700820803642273 , 0.8896471261978149 , 0.8973260521888733 , 0.9196945428848267 , 0.9411463737487793 ] } iex(7)&gt; Enum . map ( word_ids , fn word_id -&gt; index_to_word [ word_id ] end ) [ &quot;dog&quot; , &quot;dogs&quot; , &quot;puppy&quot; , &quot;cats&quot; , &quot;animal&quot; , &quot;horse&quot; , &quot;rabbit&quot; , &quot;paws&quot; , &quot;pig&quot; , &quot;paw&quot; ] Installation n.b. This library currently only runs on Linux. You will need a C++14 compiler and the Erlang header files required for compiling NIFs. If available in Hex , the package can be installed by adding annoy_ex to your list of dependencies in mix.exs : def deps do [ { :annoy_ex , &quot;~&gt; 1.0.0&quot; } ] end Working with source Before running tests make sure to build the shared library with make annoy","ref":"readme.html#word-embeddings-with-pretrained-glove-vectors","title":"AnnoyEx - Word Embeddings with Pretrained GloVe vectors","type":"extras"}]